﻿
using System.IO;

namespace AssemblyLoadTest
{
    using System;
    using System.Reflection;
    using CommonInterface;

    class Program
    {
        static void Main(string[] args)
        {
            var derivedType = GetAssemblyType("CastTest.dll", "CastTest.Derived");
            var derived = Activator.CreateInstance(derivedType);
            var commons = derived as ICommons;

            TypeCast.TypeCast.Cast(commons);
        }

        public static Type GetAssemblyType(string filePath, string className)
        {
            // Assembly.Load는 형변환 실패함.
            //var bytes = File.ReadAllBytes(filePath);
            //var obj = Assembly.Load(bytes);

            var obj = Assembly.LoadFrom(filePath);

            return obj.GetType(className);
        }
    }
}
